const svcNS    = require('../../definition.js').svcNS;
const EppError = require('../../common/EppError.js');
const element  = require('../../common/element.js');
const token    = require('../../common/token.js');
const authInfo_= require('../../common/contact/authInfo.js');

function epp2json(node) {
    let _id = undefined, _authInfo = undefined,
        transfer = element.array(node);
    for(let i=0; i<transfer.length; i++)
        switch(transfer[i][0]) {
        case 'contact:id':
            element.limit(transfer[i], _id!==undefined);
            _id = transfer[i];
            break;
        case 'contact:authInfo':
            element.limit(transfer[i], _authInfo!==undefined);
            _authInfo = transfer[i];
            break;
        default:
            throw new EppError(transfer[i], transfer[i][0]+': unknown');
        }
    element.exist(node, 'contact:id', _id!==undefined);

    let json = {
        command: 'transfer',
        obj: 'contact',
        id: token("{3,16}").epp2json(_id)
    }
    if(_authInfo!==undefined)
        json.authInfo = authInfo_.epp2json(_authInfo);
    return json;
}

function json2epp(json) {
    let transfer = [
        ['contact:id', {}, token("{3,16}").json2epp(json, 'id')]
    ]
    if(json.authInfo!==undefined)
        transfer.push(authInfo_.json2epp(json.authInfo));
    return transfer;
}

module.exports = {
    epp2json,
    json2epp: json => ["contact:transfer", {"xmlns:contact": svcNS.contact}, json2epp(json)]
}
