const element = require('../common/element.js');
const TAG = {
    'check': {
        'launch:check' : require('../extension/launch/check.js'),
        'fee:check'    : require('../extension/fee/check.js')
    },
    'info': {
        'launch:info'  : require('../extension/launch/info.js')
    },
    'create': {
        'secDNS:create': require('../extension/secDNS/create.js'),
        'launch:create': require('../extension/launch/create.js'),
        'fee:create'   : require('../extension/fee/create.js')
    },
    'renew': {
        'fee:renew'    : require('../extension/fee/renew.js')
    },
    'transfer': {
        'fee:transfer' : require('../extension/fee/transfer.js')
    },
    'delete': {
        'launch:delete': require('../extension/launch/delete.js')
    },
    'update': {
        'rgp:update'   : require('../extension/rgp/update.js'),
        'secDNS:update': require('../extension/secDNS/update.js'),
        'launch:update': require('../extension/launch/update.js'),
        'fee:update'   : require('../extension/fee/update.js')
    }
}

function epp2json(command, node) {
    let json = {},
        extension = element.array(node);
    for(let i=0; i<extension.length; i++) {
        let cmd = element.tag(extension[i], Object.keys(TAG[command]));
        json[cmd[0]] = TAG[command][cmd[0]].epp2json(cmd);
    }
    return json;
}

function json2epp(command, json) {
    let extension = [];
    for(let key in json) {
        element.keys(json, key, Object.keys(TAG[command]));
        extension.push(TAG[command][key].json2epp(json, key));
    }
    return extension;
}

module.exports = {
    epp2json,
    json2epp: (command, json) => ['extension', {}, json2epp(command, json)]
}
