const svcNS    = require('../../definition.js').svcNS;
const EppError = require('../../common/EppError.js');
const element  = require('../../common/element.js');
const label_   = require('../../common/label.js');
const addr_    = require('../../common/host/addr.js');

function epp2json(node) {
    let _name = undefined, _addr = [],
        create = element.array(node);
    for(let i=0; i<create.length; i++)
        switch(create[i][0]) {
        case 'host:name':
            element.limit(create[i], _name!==undefined);
            _name = create[i];
            break;
        case 'host:addr':
            _addr.push(create[i]);
            break;
        default:
            throw new EppError(create[i], create[i][0]+': unknown');
        }
    element.exist(node, 'domain:name', _name!==undefined);

    let json = {
        command: 'create',
        obj: 'host',
        name: label_.epp2json(_name)
    }
    if(_addr.length)
        json.addr = addr_.epp2json(_addr);
    return json;
}

function json2epp(json) {
    let create = [
        ['host:name', {}, label_.json2epp(json, 'name')]
    ]
    if(json.addr instanceof Array)
        create.push(...addr_.json2epp(json));
    return create;
}

module.exports = {
    epp2json,
    json2epp: json => ["host:create", {"xmlns:host": svcNS.host}, json2epp(json)]
}
