const element  = require('../common/element.js');
const token    = require('../common/token.js');
const TAG = {
    'login'    : require('./login.js'),
    'logout'   : require('./logout.js'),
    'poll'     : require('./poll.js'),
    'check'    : require('./check.js'),
    'info'     : require('./info.js'),
    'transfer' : require('./transfer.js'),
    'create'   : require('./create.js'),
    'delete'   : require('./delete.js'),
    'renew'    : require('./renew.js'),
    'update'   : require('./update.js')
}
const extension= require('./extension.js');
const TAGKEY   = Object.keys(TAG);

function clTRID(command) {
    let guid = 'CLIENT-' + command + '-';
    for(let i=1; i<=32; i++) {
        guid += Math.floor(Math.random() * 16.0).toString(16);
        if(i==8 || i==12 || i==16 || i==20) guid += "-";
    }
    return guid;
}

function epp2json(node) {
    let _command = undefined, _extension = undefined, _clTRID = undefined,
        epp = element.array(node);
    for(let i=0; i<epp.length; i++)
        switch(epp[i][0]) {
        case 'extension':
            element.limit(epp[i], _extension!==undefined);
            _extension = epp[i];
            break;
        case 'clTRID':
            element.limit(epp[i], _clTRID!==undefined);
            _clTRID = epp[i];
            break;
        default:
            let temp = element.tag(epp[i], TAGKEY);
            element.limit(epp[i], _command!==undefined);
            _command = temp;
        }
    element.exist(node, TAGKEY.join('|'), _command!==undefined);
    element.exist(node, 'clTRID', _clTRID!==undefined);

    let json = {format: "command"}
    Object.assign(json, TAG[_command[0]].epp2json(_command));
    if(_extension!==undefined)
        json.extension = extension.epp2json(_command[0], _extension);
    json.clTRID = token("{3,64}").epp2json(_clTRID);
    return json;
}

function json2epp(json) {
    let key = element.value(json, 'command', TAGKEY),
        command = [TAG[key].json2epp(json)];
    if(json.extension!==undefined)
        command.push(extension.json2epp(key, json.extension));
    json.clTRID = json.clTRID || clTRID(json.command);
    command.push(['clTRID', {}, token("{3,64}").json2epp(json, 'clTRID')]);
    return command;
}

module.exports = {
    epp2json,
    json2epp: json => ['command', {}, json2epp(json)]
}
