const element = require('../common/element.js');
const TAG = {
    'domain'  : require('./domain/info.js'),
    'host'    : require('./host/info.js'),
    'contact' : require('./contact/info.js')
}
const TAGKEY  = Object.keys(TAG);
const TAGMAP  = TAGKEY.map(obj => obj+':info');

function epp2json(node) {
    let epp = element.tag(element.array(node, [1])[0], TAGMAP);
    return TAG[epp[0].split(':')[0]].epp2json(epp);
}

function json2epp(json) {
    let obj = element.value(json, 'obj', TAGKEY);
    return [TAG[obj].json2epp(json)]
}

module.exports = {
    epp2json,
    json2epp: json => ['info', {}, json2epp(json)]
}
