const element  = require('../common/element.js');
const token    = require('../common/token.js');
const OPTYPE   = ['req', 'ack']

function epp2json(node) {
    let json = {
        command: 'poll',
        op: element.attribute(node, 'op', OPTYPE)
    }
    if(json.op==='ack')
        json.msgID = token("+").epp2json(node, 'msgID');
    return json;
}

function json2epp(json) {
    let attrs = {
        op: element.value(json, 'op', OPTYPE)
    }
    if(attrs.op==='ack')
        attrs.msgID = token("+").json2epp(json, 'msgID');
    return ["poll", attrs]
}

module.exports = {
    epp2json,
    json2epp
}
