const element = require('../common/element.js');
const TAG = {
    'domain'  : require('./domain/transfer.js'),
    'contact' : require('./contact/transfer.js')
}
const TAGKEY  = Object.keys(TAG);
const TAGMAP  = TAGKEY.map(obj => obj+':transfer');
const OPTYPE  = ['approve', 'cancel', 'query', 'reject', 'request']

function epp2json(node) {
    let epp = element.tag(element.array(node, [1])[0], TAGMAP);
    return TAG[epp[0].split(':')[0]].epp2json(epp);
}

function json2epp(json) {
    let obj = element.value(json, 'obj', TAGKEY);
    return [TAG[obj].json2epp(json)]
}

module.exports = {
    epp2json: node => Object.assign({op: element.attribute(node, 'op', OPTYPE)}, epp2json(node)),
    json2epp: json => ['transfer', {op: element.value(json, 'op', OPTYPE)}, json2epp(json)]
}
