const element = require('./element.js');
const BOOL = {
    '0'    : false,
    '1'    : true,
    'false': false,
    'true' : true
}
const KEYS = Object.keys(BOOL);

function epp2json(node, key) {
    let s = key===undefined
          ? element.string(node, KEYS)
          : element.attribute(node, key, KEYS);
    return BOOL[s];
}

function json2epp(json, ...args) {
    let [n, s] = element.pair(json, ...args);
    if(typeof(s)!=='boolean')
        throw new EppError(json, n+': expect a boolean');
    return s.toString();
}

module.exports = {
    epp2json,
    json2epp
}
