const EppError = require('../EppError.js');
const element  = require('../element.js');
const token    = require('../token.js');
const patt     = /^(\+\d{1,3}\.\d{1,14})?$/;

function epp2json(node) {
    let s = element.string(node);
    if(!patt.test(s))
        throw new EppError(node, node[0]+': '+patt);
    return node[1].x!==undefined
         ? [s, token("*").epp2json(node, 'x')]
         : [s];
}

function json2epp(json, key) {
    let _e164 = element.value(json, key),
        attrs = {}, s = undefined;
    if(_e164 instanceof Array && _e164.length) {
        if(_e164.length > 1)
            attrs.x = token("*").json2epp(json, key, 1);
        if(!patt.test(_e164[0]))
            throw new EppError(json, key+': '+patt);
        s = _e164[0];
    }
    return ['contact:'+key, attrs, s]
}

module.exports = {
    epp2json,
    json2epp
}
