const EppError = require('./EppError.js');
const element  = require('./element.js');

function epp2json(node) {
    let date = new Date(element.string(node).replace(/^\s+|\s+$/g, ""));
    if(!(date instanceof Date))
        throw new EppError(node, node[0]+': expect a date');
    return date;
}

function json2epp(json, ...args) {
    const DATE = /^\d{4}-\d{2}-\d{2}T\d{2}:\d{2}:\d{2}\.\d{1,3}Z$/;
    let [n, s] = element.pair(json, ...args);
    if(typeof(s)==='string' && DATE.test(s)) return s;
    if(!(s instanceof Date))
        throw new EppError(json, n+': expect a date');
    return s.toISOString();
}

module.exports = {
    epp2json,
    json2epp
}
