const punycode = require('punycode');
const EppError = require('./EppError.js');
const element  = require('./element.js');
const patt     = /^[a-zA-Z0-9]([a-zA-Z0-9\-]*[a-zA-Z0-9])?(\.[a-zA-Z0-9]([a-zA-Z0-9\-]*[a-zA-Z0-9])?)+$/;

function epp2json(node) {
    let s = element.string(node).replace(/^\s+|\s+$/g, "");
    if(!patt.test(s))
        throw new EppError(node, node[0]+': '+patt);
    return punycode.toUnicode(s);
}

function json2epp(json, ...args) {
    let [n, s] = element.pair(json, ...args);
    if(typeof(s)!=='string')
        throw new EppError(json, n+': expect a string');
    s = punycode.toASCII(s.replace(/^\s+|\s+$/g, ""));
    if(!patt.test(s))
        throw new EppError(json, n+': '+patt);
    return s;
}

module.exports = {
    epp2json,
    json2epp
}
