const EppError = require('./EppError.js');
const element  = require('./element.js');
const patt     = /^[a-zA-Z0-9_]{1,80}-[a-zA-Z0-9]{1,8}$/;

function epp2json(node, key) {
    let s = key===undefined
          ? element.string(node)
          : element.attribute(node, key),
        n = key===undefined
          ? node[0]
          : node[0]+'.'+key;
    s = s.replace(/^\s+|\s+$/g, "");
    if(!patt.test(s))
        throw new EppError(node, n+': '+patt);
    return s;
}

function json2epp(json, ...args) {
    let [n, s] = element.pair(json, ...args);
    if(typeof(s)!=='string')
        throw new EppError(json, n+': expect a string');
    s = s.replace(/^\s+|\s+$/g, "");
    if(!patt.test(s))
        throw new EppError(json, n+': '+patt);
    return s;
}

module.exports = {
    epp2json,
    json2epp
}
