const EppError = require('./EppError.js');
const element  = require('./element.js');

module.exports = function(size) {
    let patt = new RegExp('^[\\s\\x21-\\x7E\\x80-\\u2027\\u202A-\\uD7FF\\uE000-\\uFFFD]'+size+'$');
    return {
        epp2json: function(node, key) {
            let s = key===undefined
                  ? element.string(node)
                  : element.attribute(node, key),
                n = key===undefined
                  ? node[0]
                  : node[0]+'.'+key;
            if(!patt.test(s))
                throw new EppError(node, n+': '+patt);
            return s;
        },
        json2epp: function(json, ...args) {
            let [n, s] = element.pair(json, ...args);
            if(typeof(s)!=='string')
                throw new EppError(json, n+': expect a string');
            if(!patt.test(s))
                throw new EppError(json, n+': '+patt);
            return s;
        }
    }
}
