const EppError = require('./EppError.js');
const element  = require('./element.js');
const patt     = /^\d+$/;

function epp2json(node, key) {
    let s = key===undefined
          ? element.string(node)
          : element.attribute(node, key),
        n = key===undefined
          ? node[0]
          : node[0]+'.'+key;
    if(!patt.test(s))
        throw new EppError(node, n+': '+patt);
    return parseInt(s, 10);
}

function json2epp(json, ...args) {
    let [n, s] = element.pair(json, ...args);
    if(typeof(s)!=='number')
        throw new EppError(json, n+': expect a unsigned');
    s = s.toString();
    if(!patt.test(s))
        throw new EppError(json, n+': '+patt);
    return s;
}

module.exports = {
    epp2json,
    json2epp
}
