const xml     = require('../xml.js');
const convert = require('../index.js');

function exception(SyntaxError, e) {
    if(!(e instanceof SyntaxError))
        throw e;
}

function test(_xml) {
    try {
        var epp = xml.parse(_xml);
    }
    catch(e) {
        exception(xml.SyntaxError, e);
        return {message: e.message, location: e.location}
    }
    try {
        var json = convert.parse(epp);
    }
    catch(e) {
        exception(convert.SyntaxError, e);
        return {message: e.message}
    }
    try {
        var epp2 = convert.stringify(json);
    }
    catch(e) {
        exception(convert.SyntaxError, e);
        return {message: e.message}
    }
    try {
        var _xml2 = xml.stringify(epp2);
    }
    catch(e) {
        exception(xml.SyntaxError, e);
        return {message: e.message, location: e.location}
    }
    return json;
}

const fs = require('fs');
if(process.argv.length < 3) {
    console.error("Usage: node test.js <rfc>");
    process.exit(1);
}
const src = 'src/'+process.argv[2]+'.txt';
const dst = 'dst/'+process.argv[2]+'.txt';

let source = fs.readFileSync(src).toString().split(/\r?\n/),
    target = [], _xml = undefined;
for(let i=0; i<source.length; i++) {
    target.push(source[i]);
    if(/^\s+[CS]:/.test(source[i])) {
        let line = source[i].replace(/^\s+[CS]:/, '');
        if(/^\s*<\?xml /.test(line))
            _xml = [line];
        else if(_xml!==undefined) {
            _xml.push(line);
            if(/^\s*<\/epp>/.test(line)) {
                target.push("   "+JSON.stringify(test(_xml.join('\n')), null, 2).replace(/\r?\n/g, "\n   "));
                _xml = undefined;
            }
        }
    }
}
fs.writeFileSync(dst, target.join('\n'));
