const svcNS    = require('../../definition.js').svcNS;
const EppError = require('../../common/EppError.js');
const element  = require('../../common/element.js');
const currency = require('./currency.js');
const command  = require('./command.js');

function epp2json(node) {
    let _currency = undefined, _command = [],
        check = element.array(node);
    for(let i=0; i<check.length; i++)
        switch(check[i][0]) {
        case 'fee:currency':
            element.limit(check[i], _currency!==undefined);
            _currency = check[i];
            break;
        case 'fee:command':
            _command.push(check[i]);
            break;
        default:
            throw new EppError(check[i], check[i][0]+': unknown');
        }

    let json = {}
    if(_currency!==undefined)
        json.currency = currency.epp2json(_currency);
    if(_command.length)
        json.command = _command.map(command.epp2json);
    return json;
}

function json2epp(json) {
    let check = []
    if(json.currency!==undefined)
        check.push(['fee:currency', {}, currency.json2epp(json, 'currency')]);
    if(json.command instanceof Array)
        check.push(...json.command.map(command.json2epp));
    return check;
}

module.exports = {
    epp2json,
    json2epp: (json, key) => ['fee:check', {'xmlns:fee': svcNS.fee}, json2epp(json[key])]
}
