const svcNS    = require('../../definition.js').svcNS;
const EppError = require('../../common/EppError.js');
const element  = require('../../common/element.js');
const currency = require('./currency.js');
const objectCD = require('./objectCD.js');

function epp2json(node) {
    let _currency = undefined, _cd = [],
        chkData = element.array(node);
    for(let i=0; i<chkData.length; i++)
        switch(chkData[i][0]) {
        case 'fee:currency':
            element.limit(chkData[i], _currency!==undefined);
            _currency = chkData[i];
            break;
        case 'fee:cd':
            _cd.push(chkData[i]);
            break;
        default:
            throw new EppError(chkData[i], chkData[i][0]+': unknown');
        }
    //element.exist(node, 'fee:currency', _currency!==undefined);

    let json = {}
    if(_currency!==undefined)
        json.currency = currency.epp2json(_currency);
    if(_cd.length)
        json.cd = _cd.map(objectCD.epp2json);
    return json;
}

function json2epp(json) {
    let chkData = []
    if(json.currency!==undefined)
        chkData.push(['fee:currency', {}, currency.json2epp(json, 'currency')]);
    if(json.cd instanceof Array)
        chkData.push(...json.cd.map(objectCD.json2epp));
    return chkData;
}

module.exports = {
    epp2json,
    json2epp: (json, key) => ['fee:chkData', {'xmlns:fee': svcNS.fee}, json2epp(json[key])]
}
