const element = require('../../common/element.js');
const token   = require('../../common/token.js');
const period_ = require('../../common/domain/period.js');
const COMMAND = ["create", "delete", "renew", "update", "transfer", "restore", "custom"]

function epp2json(node) {
    let json = {name: element.attribute(node, 'name', COMMAND)}
    if(node[1].customName!==undefined)
        json.customName = token("+").epp2json(node, 'customName');
    if(node[1].phase!==undefined)
        json.phase = token("+").epp2json(node, 'phase');
    if(node[1].subphase!==undefined)
        json.subphase = token("+").epp2json(node, 'subphase');
    if(node[2]!==undefined)
        json.period = period_.epp2json(element.tag(element.array(node, [1])[0], ['fee:period']));
    return json;
}

function json2epp(json) {
    let attrs = {name: element.value(json, 'name', COMMAND)}
    if(json.customName!==undefined)
        attrs.customName = token("+").json2epp(json, 'customName');
    if(json.phase!==undefined)
        attrs.phase = token("+").json2epp(json, 'phase');
    if(json.subphase!==undefined)
        attrs.subphase = token("+").json2epp(json, 'subphase');
    return ['fee:command', attrs, json.period!==undefined ? [period_.json2epp('fee', json.period)] : undefined]
}

module.exports = {
    epp2json,
    json2epp
}
