const EppError = require('../../common/EppError.js');
const element  = require('../../common/element.js');
const patt     = /^[A-Z]{3}$/;

function epp2json(node, key) {
    let s = key===undefined
          ? element.string(node)
          : element.attribute(node, key),
        n = key===undefined
          ? node[0]
          : node[0]+'.'+key;
    if(!patt.test(s))
        throw new EppError(node, n+': '+patt);
    return s;
}

function json2epp(json, ...args) {
    let [n, s] = element.pair(json, ...args);
    if(typeof(s)!=='string')
        throw new EppError(json, n+': expect a string');
    if(!patt.test(s))
        throw new EppError(json, n+': '+patt);
    return s;
}

module.exports = {
    epp2json,
    json2epp
}
