const element = require('../../common/element.js');
const bool    = require('../../common/boolean.js');
const token   = require('../../common/token.js');
const string  = require('../../common/string.js');
const decimal = require('../../common/float.js');
const APPLIED = ["immediate", "delayed"]

function epp2json(node) {
    let json = [decimal.epp2json('+', node)],
        attrs = {}
    if(node[1]["description"]!==undefined)
        attrs["description"] = string("+").epp2json(node, "description");
    if(node[1]["refundable"]!==undefined)
        attrs["refundable"] = bool.epp2json(node, "refundable");
    if(node[1]["grace-period"]!==undefined)
        attrs["grace-period"] = token("+").epp2json(node, "grace-period");
    if(node[1]["applied"]!==undefined)
        attrs["applied"] = element.attribute(node, "applied", APPLIED);
    if(Object.keys(attrs).length)
        json.push(attrs);
    return json;
}

function json2epp(json) {
    let fee = decimal.json2epp('+', json, 0),
        attrs = {}
    if(json.length > 1) {
        if(json[1]["description"]!==undefined)
            attrs["description"] = string("+").json2epp(json[1], "description");
        if(json[1]["refundable"]!==undefined)
            attrs["refundable"] = bool.json2epp(json[1], "refundable");
        if(json[1]["grace-period"]!==undefined)
            attrs["grace-period"] = token("+").json2epp(json[1], "grace-period");
        if(json[1]["applied"]!==undefined)
            attrs["applied"] = element.value(json[1], "applied", APPLIED);
    }
    return ['fee:fee', attrs, fee]
}

module.exports = {
    epp2json,
    json2epp
}
