const svcNS   = require('../../definition.js').svcNS;
const element = require('../../common/element.js');
const phase_  = require('./phase.js');
const TYPE    = ["claims", "avail", "trademark"]

function epp2json(node) {
    let json = {type: element.attribute(node, 'type', TYPE)}
    if(node[2]!==undefined)
        json.phase = phase_.epp2json(element.array(node, [1])[0]);
    return json;
}

function json2epp(json) {
    let type = element.value(json, 'type', TYPE),
        value = json.phase ? [phase_.json2epp(json)] : undefined;
    return ['launch:check', {'xmlns:launch': svcNS.launch, type}, value]
}

module.exports = {
    epp2json,
    json2epp: (json, key) => json2epp(json[key])
}
