const element = require('../../common/element.js');
const token   = require('../../common/token.js');

function epp2json(claimKey) {
    let json = [token("+").epp2json(claimKey)]
    if(claimKey[1].validatorID!==undefined)
        json.push(token("+").epp2json(claimKey, 'validatorID'));
    return json;
}

function json2epp(json) {
    let epp = [], claimKey = element.value(json, 'claimKey');
    for(let i=0; i<claimKey.length; i++) {
        let attrs = {}
        if(claimKey[i].length > 1)
            attrs.validatorID = token("+").json2epp(json, 'claimKey', i, 1);
        epp.push(['launch:claimKey', attrs, token("+").json2epp(json, 'claimKey', i, 0)]);
    }
    return epp;
}

module.exports = {
    epp2json: node => node.map(epp2json),
    json2epp
}
