const element  = require('../../common/element.js');
const dateTime = require('../../common/dateTime.js');
const noticeID = require('./noticeID.js');

function epp2json(node) {
    let notice = element.array(node, [3]);
    return {
        noticeID: noticeID.epp2json(element.tag(notice[0], ["launch:noticeID"])),
        notAfter: dateTime.epp2json(element.tag(notice[1], ["launch:notAfter"])),
        acceptedDate: dateTime.epp2json(element.tag(notice[2], ["launch:acceptedDate"]))
    }
}

function json2epp(json) {
    return [
        noticeID.json2epp(json),
        ["launch:notAfter", {}, dateTime.json2epp(json, 'notAfter')],
        ["launch:acceptedDate", {}, dateTime.json2epp(json, 'acceptedDate')]
    ]
}

module.exports = {
    epp2json,
    json2epp: json => ['launch:notice', {}, json2epp(json)]
}
