const element  = require('../../common/element.js');
const unsigned = require('../../common/unsigned.js');
const token    = require('../../common/token.js');
const keyData  = require('./keyData.js');

function epp2json(node) {
    let dsData = element.array(node, [4, 5]);
    let json = {
        keyTag    : unsigned.epp2json(element.tag(dsData[0], ['secDNS:keyTag'])),
        alg       : unsigned.epp2json(element.tag(dsData[1], ['secDNS:alg'])),
        digestType: unsigned.epp2json(element.tag(dsData[2], ['secDNS:digestType'])),
        digest    : token("+").epp2json(element.tag(dsData[3], ['secDNS:digest']))
    }
    if(dsData.length===5)
        json.keyData = keyData.epp2json(element.tag(dsData[4], ['secDNS:keyData']));
    return json;
}

function json2epp(json) {
    let dsData = [
        ['secDNS:keyTag', {}, unsigned.json2epp(json, 'keyTag')],
        ['secDNS:alg', {}, unsigned.json2epp(json, 'alg')],
        ['secDNS:digestType', {}, unsigned.json2epp(json, 'digestType')],
        ['secDNS:digest', {}, token("+").json2epp(json, 'digest')]
    ]
    if(json.keyData!==undefined)
        dsData.push(['secDNS:keyData', {}, keyData.json2epp(json.keyData)]);
    return dsData;
}

module.exports = {
    epp2json,
    json2epp
}
