const element  = require('../../common/element.js');
const unsigned = require('../../common/unsigned.js');
const token    = require('../../common/token.js');

function epp2json(node) {
    let keyData = element.array(node, [4]);
    return {
        flags   : unsigned.epp2json(element.tag(keyData[0], ['secDNS:flags'])),
        protocol: unsigned.epp2json(element.tag(keyData[1], ['secDNS:protocol'])),
        alg     : unsigned.epp2json(element.tag(keyData[2], ['secDNS:alg'])),
        pubKey  : token("+").epp2json(element.tag(keyData[3], ['secDNS:pubKey']))
    }
}

function json2epp(json) {
    return [
        ['secDNS:flags', {}, unsigned.json2epp(json, 'flags')],
        ['secDNS:protocol', {}, unsigned.json2epp(json, 'protocol')],
        ['secDNS:alg', {}, unsigned.json2epp(json, 'alg')],
        ['secDNS:pubKey', {}, token("+").json2epp(json, 'pubKey')]
    ]
}

module.exports = {
    epp2json,
    json2epp
}
