const definition = require('./definition.js');
const element    = require('./common/element.js');
const string     = require('./common/string.js');
const dateTime   = require('./common/dateTime.js');

function epp2json(node) {
    let greeting = element.array(node, [4]);
    return {
        format: "greeting",
        svID  : string("{3,64}").epp2json(element.tag(greeting[0], ["svID"])),
        svDate: dateTime.epp2json(element.tag(greeting[1], ["svDate"]))
    }
}

function json2epp(json) {
    return [
        ["svID", {}, string("{3,64}").json2epp(json, 'svID')],
        ["svDate", {}, dateTime.json2epp(json, 'svDate')],
        ["svcMenu", {}, [
            ["version", {}, definition.version],
            ["lang", {}, definition.lang],
            ...definition.svcURI
        ]],
        ["dcp", {}, [
            ["access", {}, [
                ["all", {}]
            ]],
            ["statement", {}, [
                ["purpose", {}, [["admin", {}], ["prov", {}]]],
                ["recipient", {}, [["ours", {}], ["public", {}]]],
                ["retention", {}, [["stated", {}]]]
            ]]
        ]]
    ]
}

module.exports = {
    epp2json,
    json2epp: json => ["greeting", {}, json2epp(json)]
}
