const element = require('./common/element.js');
const TAG = {
    'hello'   : require('./hello.js'),
    'greeting': require('./greeting.js'),
    'command' : require('./command'),
    'response': require('./response')
}
const TAGKEY  = Object.keys(TAG);

function epp2json(epp) {
    let format = element.tag(element.array(epp, [1])[0], TAGKEY);
    return TAG[format[0]].epp2json(format);
}

function json2epp(json) {
    let key = element.value(json, 'format', TAGKEY);
    return [TAG[key].json2epp(json)];
}

module.exports = {
    SyntaxError: require('./common/EppError.js'),
    parse: node => epp2json(element.tag(node, ['epp'])),
    stringify: json => ['epp', {xmlns: 'urn:ietf:params:xml:ns:epp-1.0'}, json2epp(json)]
}
