const svcNS    = require('../../definition.js').svcNS;
const element  = require('../../common/element.js');
const token    = require('../../common/token.js');
const dateTime = require('../../common/dateTime.js');

function epp2json(node) {
    let creData = element.array(node, [2]);
    return {
        obj: "contact",
        type: "creData",
        id: token("{3,16}").epp2json(element.tag(creData[0], ['contact:id'])),
        crDate: dateTime.epp2json(element.tag(creData[1], ['contact:crDate']))
    }
}

function json2epp(json) {
    return [
        ['contact:id', {}, token("{3,16}").json2epp(json, 'id')],
        ['contact:crDate', {}, dateTime.json2epp(json, 'crDate')]
    ]
}

module.exports = {
    epp2json,
    json2epp: json => ["contact:creData", {"xmlns:contact": svcNS.contact}, json2epp(json)]
}
