const svcNS   = require('../../definition.js').svcNS;
const element = require('../../common/element.js');
const token   = require('../../common/token.js');
const bool    = require('../../common/boolean.js');
const dateTime= require('../../common/dateTime.js');
const trID_   = require('../trID.js');

function epp2json(node) {
    let panData = element.array(node, [3]);
    return {
        obj: "contact",
        type: "panData",
        id: token("{3,16}").epp2json(element.tag(panData[0], ['contact:id'])),
        paResult: bool.epp2json(panData[0], 'paResult'),
        paTRID: trID_.epp2json(element.tag(panData[1], ['contact:paTRID'])),
        paDate: dateTime.epp2json(element.tag(panData[2], ['contact:paDate']))
    }
}

function json2epp(json) {
    return [
        ['contact:id', {paResult: bool.json2epp(json, 'paResult')}, token("{3,16}").json2epp(json, 'id')],
        ['contact:paTRID', {}, trID_.json2epp(element.value(json, 'paTRID'))],
        ['contact:paDate', {}, dateTime.json2epp(json, 'paDate')]
    ]
}

module.exports = {
    epp2json,
    json2epp: json => ["contact:panData", {"xmlns:contact": svcNS.contact}, json2epp(json)]
}
