const svcNS   = require('../../definition.js').svcNS;
const element = require('../../common/element.js');
const token   = require('../../common/token.js');
const dateTime= require('../../common/dateTime.js');
const STATUS  = ['clientApproved', 'clientCancelled', 'clientRejected', 'pending', 'serverApproved', 'serverCancelled']

function epp2json(node) {
    let trnData = element.array(node, [6]);
    return {
        obj: 'contact',
        type: 'trnData',
        id: token("{3,16}").epp2json(element.tag(trnData[0], ['contact:id'])),
        trStatus: element.string(element.tag(trnData[1], ['contact:trStatus']), STATUS),
        reID: token("{3,16}").epp2json(element.tag(trnData[2], ['contact:reID'])),
        reDate: dateTime.epp2json(element.tag(trnData[3], ['contact:reDate'])),
        acID: token("{3,16}").epp2json(element.tag(trnData[4], ['contact:acID'])),
        acDate: dateTime.epp2json(element.tag(trnData[5], ['contact:acDate']))
    }
}

function json2epp(json) {
    return [
        ['contact:id', {}, token("{3,16}").json2epp(json, 'id')],
        ['contact:trStatus', {}, element.value(json, 'trStatus', STATUS)],
        ['contact:reID', {}, token("{3,16}").json2epp(json, 'reID')],
        ['contact:reDate', {}, dateTime.json2epp(json, 'reDate')],
        ['contact:acID', {}, token("{3,16}").json2epp(json, 'acID')],
        ['contact:acDate', {}, dateTime.json2epp(json, 'acDate')]
    ]
}

module.exports = {
    epp2json,
    json2epp: json => ["contact:trnData", {"xmlns:contact": svcNS.contact}, json2epp(json)]
}
