const svcNS    = require('../../definition.js').svcNS;
const EppError = require('../../common/EppError.js');
const element  = require('../../common/element.js');
const label_   = require('../../common/label.js');
const dateTime = require('../../common/dateTime.js');

function epp2json(node) {
    let creData = element.array(node);
    switch(creData.length) {
    case 2:
    case 3:
        break;
    default:
        throw new EppError(node, node[0]+': only have 2|3 subelement');
    }

    let json = {
        obj: "domain",
        type: "creData",
        name: label_.epp2json(element.tag(creData[0], ['domain:name'])),
        crDate: dateTime.epp2json(element.tag(creData[1], ['domain:crDate']))
    }
    if(creData.length===3)
        json.exDate = dateTime.epp2json(element.tag(creData[2], ['domain:exDate']));
    return json;
}

function json2epp(json) {
    let creData = [
        ['domain:name', {}, label_.json2epp(json, 'name')],
        ['domain:crDate', {}, dateTime.json2epp(json, 'crDate')]
    ]
    if(json.exDate!==undefined)
        creData.push(['domain:exDate', {}, dateTime.json2epp(json, 'exDate')]);
    return creData;
}

module.exports = {
    epp2json,
    json2epp: json => ["domain:creData", {"xmlns:domain": svcNS.domain}, json2epp(json)]
}
