const svcNS   = require('../../definition.js').svcNS;
const element = require('../../common/element.js');
const label_  = require('../../common/label.js');
const dateTime= require('../../common/dateTime.js');

function epp2json(node) {
    let renData = element.array(node, [2]);
    return {
        obj: "domain",
        type: "renData",
        name: label_.epp2json(element.tag(renData[0], ['domain:name'])),
        exDate: dateTime.epp2json(element.tag(renData[1], ['domain:exDate']))
    }
}

function json2epp(json) {
    return [
        ['domain:name', {}, label_.json2epp(json, 'name')],
        ['domain:exDate', {}, dateTime.json2epp(json, 'exDate')]
    ]
}

module.exports = {
    epp2json,
    json2epp: json => ["domain:renData", {"xmlns:domain": svcNS.domain}, json2epp(json)]
}
