const svcNS   = require('../../definition.js').svcNS;
const element = require('../../common/element.js');
const label_  = require('../../common/label.js');
const token   = require('../../common/token.js');
const dateTime= require('../../common/dateTime.js');
const STATUS  = ['clientApproved', 'clientCancelled', 'clientRejected', 'pending', 'serverApproved', 'serverCancelled']

function epp2json(node) {
    let trnData = element.array(node, [7]);
    return {
        obj: 'domain',
        type: 'trnData',
        name: label_.epp2json(element.tag(trnData[0], ['domain:name'])),
        trStatus: element.string(element.tag(trnData[1], ['domain:trStatus']), STATUS),
        reID: token("{3,16}").epp2json(element.tag(trnData[2], ['domain:reID'])),
        reDate: dateTime.epp2json(element.tag(trnData[3], ['domain:reDate'])),
        acID: token("{3,16}").epp2json(element.tag(trnData[4], ['domain:acID'])),
        acDate: dateTime.epp2json(element.tag(trnData[5], ['domain:acDate'])),
        exDate: dateTime.epp2json(element.tag(trnData[6], ['domain:exDate']))
    }
}

function json2epp(json) {
    return [
        ['domain:name', {}, label_.json2epp(json, 'name')],
        ['domain:trStatus', {}, element.value(json, 'trStatus', STATUS)],
        ['domain:reID', {}, token("{3,16}").json2epp(json, 'reID')],
        ['domain:reDate', {}, dateTime.json2epp(json, 'reDate')],
        ['domain:acID', {}, token("{3,16}").json2epp(json, 'acID')],
        ['domain:acDate', {}, dateTime.json2epp(json, 'acDate')],
        ['domain:exDate', {}, dateTime.json2epp(json, 'exDate')]
    ]
}

module.exports = {
    epp2json,
    json2epp: json => ["domain:trnData", {"xmlns:domain": svcNS.domain}, json2epp(json)]
}
