const element = require('../common/element.js');
const TAG = {
    'chkData': {
        'fee:chkData'   : require('../extension/fee/chkData.js')
    },
    'infData': {
        'rgp:infData'   : require('../extension/rgp/infData.js'),
        'secDNS:infData': require('../extension/secDNS/infData.js'),
        'launch:infData': require('../extension/launch/infData.js')
    },
    'creData': {
        'launch:creData': require('../extension/launch/creData.js'),
        'fee:creData'   : require('../extension/fee/creData.js')
    },
    'renData': {
        'fee:renData'   : require('../extension/fee/renData.js')
    },
    'trnData': {
        'fee:trnData'   : require('../extension/fee/trnData.js')
    },
    'panData': {
        'launch:infData': require('../extension/launch/infData.js')
    },
    'resData': {
        'rgp:upData'    : require('../extension/rgp/upData.js'),
        'launch:chkData': require('../extension/launch/chkData.js'),
        'fee:delData'   : require('../extension/fee/delData.js'),
        'fee:updData'   : require('../extension/fee/updData.js')
    }
}

function epp2json(type, node) {
    let json = {},
        extension = element.array(node);
    for(let i=0; i<extension.length; i++) {
        let epp = element.tag(extension[i], Object.keys(TAG[type]));
        json[epp[0]] = TAG[type][epp[0]].epp2json(epp);
    }
    return json;
}

function json2epp(type, json) {
    let extension = [];
    for(let key in json) {
        element.keys(json, key, Object.keys(TAG[type]));
        extension.push(TAG[type][key].json2epp(json, key));
    }
    return extension;
}

module.exports = {
    epp2json,
    json2epp: (type, json) => ['extension', {}, json2epp(type, json)]
}
