const svcNS    = require('../../definition.js').svcNS;
const element  = require('../../common/element.js');
const label_   = require('../../common/label.js');
const dateTime = require('../../common/dateTime.js');

function epp2json(node) {
    let creData = element.array(node, [2]);
    return {
        obj: "host",
        type: "creData",
        name: label_.epp2json(element.tag(creData[0], ['host:name'])),
        crDate: dateTime.epp2json(element.tag(creData[1], ['host:crDate']))
    }
}

function json2epp(json) {
    return [
        ['host:name', {}, label_.json2epp(json, 'name')],
        ['host:crDate', {}, dateTime.json2epp(json, 'crDate')]
    ]
}

module.exports = {
    epp2json,
    json2epp: json => ["host:creData", {"xmlns:host": svcNS.host}, json2epp(json)]
}
