const svcNS   = require('../../definition.js').svcNS;
const element = require('../../common/element.js');
const label_  = require('../../common/label.js');
const bool    = require('../../common/boolean.js');
const dateTime= require('../../common/dateTime.js');
const trID_   = require('../trID.js');

function epp2json(node) {
    let panData = element.array(node, [3]);
    return {
        obj: "host",
        type: "panData",
        name: label_.epp2json(element.tag(panData[0], ['host:name'])),
        paResult: bool.epp2json(panData[0], 'paResult'),
        paTRID: trID_.epp2json(element.tag(panData[1], ['host:paTRID'])),
        paDate: dateTime.epp2json(element.tag(panData[2], ['host:paDate']))
    }
}

function json2epp(json) {
    return [
        ['host:name', {paResult: bool.json2epp(json, 'paResult')}, label_.json2epp(json, 'name')],
        ['host:paTRID', {}, trID_.json2epp(element.value(json, 'paTRID'))],
        ['host:paDate', {}, dateTime.json2epp(json, 'paDate')]
    ]
}

module.exports = {
    epp2json,
    json2epp: json => ["host:panData", {"xmlns:host": svcNS.host}, json2epp(json)]
}
