const EppError = require('../common/EppError.js');
const element  = require('../common/element.js');
const unsigned = require('../common/unsigned.js');
const token    = require('../common/token.js');
const dateTime = require('../common/dateTime.js');
const string   = require('../common/string.js');

function epp2json(node) {
    let _qDate = undefined, _msg = undefined;
    if(node[2]!==undefined) {
        let msgQ = element.array(node);
        for(let i=0; i<msgQ.length; i++)
            switch(msgQ[i][0]) {
            case "qDate":
                element.limit(msgQ[i], _qDate!==undefined);
                _qDate = msgQ[i];
                break;
            case "msg":
                element.limit(msgQ[i], _msg!==undefined);
                _msg = msgQ[i];
                break;
            default:
                throw new EppError(msgQ[i], msgQ[i][0]+': unknown');
            }
    }

    let json = {
        count: unsigned.epp2json(node, 'count'),
        id: token("+").epp2json(node, 'id')
    }
    if(_qDate!==undefined)
        json.qDate = dateTime.epp2json(_qDate);
    if(_msg!==undefined)
        json.msg = string("+").epp2json(_msg);
    return json;
}

function json2epp(json) {
    let msgQ = [];
    if(json.qDate!==undefined)
        msgQ.push(["qDate", {}, dateTime.json2epp(json, 'qDate')]);
    if(json.msg!==undefined)
        msgQ.push(["msg", {}, string("+").json2epp(json, 'msg')]);
    return msgQ.length ? msgQ : undefined;
}

module.exports = {
    epp2json,
    json2epp: json => ['msgQ', {count: unsigned.json2epp(json, 'count'), id: token("+").json2epp(json, 'id')}, json2epp(json)]
}
