const element = require('../common/element.js');
const resData = {
    'domain:chkData' : require('./domain/chkData.js'),
    'domain:creData' : require('./domain/creData.js'),
    'domain:infData' : require('./domain/infData.js'),
    'domain:panData' : require('./domain/panData.js'),
    'domain:renData' : require('./domain/renData.js'),
    'domain:trnData' : require('./domain/trnData.js'),
    'host:chkData'   : require('./host/chkData.js'),
    'host:creData'   : require('./host/creData.js'),
    'host:infData'   : require('./host/infData.js'),
    'host:panData'   : require('./host/panData.js'),
    'contact:chkData': require('./contact/chkData.js'),
    'contact:creData': require('./contact/creData.js'),
    'contact:infData': require('./contact/infData.js'),
    'contact:panData': require('./contact/panData.js'),
    'contact:trnData': require('./contact/trnData.js')
}
const TAGKEY = Object.keys(resData);

function epp2json(node) {
    let epp = element.tag(element.array(node, [1])[0], TAGKEY);
    return resData[epp[0]].epp2json(epp);
}

function json2epp(json) {
    let tag = json.obj+':'+json.type;
    element.keys(json, tag, TAGKEY);
    return [resData[tag].json2epp(json)]
}

module.exports = {
    epp2json,
    json2epp: json => ['resData', {}, json2epp(json)]
}
