const EppError = require('../common/EppError.js');
const element  = require('../common/element.js');
const token    = require('../common/token.js');

function svTRID() {
    let guid = 'SERVER-';
    for(let i=1; i<=32; i++) {
        guid += Math.floor(Math.random() * 16.0).toString(16);
        if(i==8 || i==12 || i==16 || i==20) guid += "-";
    }
    return guid;
}

function epp2json(node) {
    let _clTRID = undefined, _svTRID = undefined,
        trID = element.array(node);
    for(let i=0; i<trID.length; i++)
        switch(trID[i][0]) {
        case 'clTRID':
            element.limit(trID[i], _clTRID!==undefined);
            _clTRID = trID[i];
            break;
        case 'svTRID':
            element.limit(trID[i], _svTRID!==undefined);
            _svTRID = trID[i];
            break;
        default:
            throw new EppError(trID[i], trID[i][0]+': unknown');
        }
    element.exist(node, 'svTRID', _svTRID!==undefined);

    let json = {}
    if(_clTRID!==undefined)
        json.clTRID = token("{3,64}").epp2json(_clTRID);
    json.svTRID = token("{3,64}").epp2json(_svTRID);
    return json;
}

function json2epp(json) {
    let trID = [];
    if(json.clTRID!==undefined)
        trID.push(['clTRID', {}, token("{3,64}").json2epp(json, 'clTRID')]);
    json.svTRID = json.svTRID || svTRID();
    trID.push(['svTRID', {}, token("{3,64}").json2epp(json, 'svTRID')]);
    return trID;
}

module.exports = {
    epp2json,
    json2epp
}
