function stringify(v) {
    var indent = 0;

    function escape(data) {
        const TT = {
            '<' : '&lt;',
            '>' : '&gt;',
            '&' : '&amp;',
            "'" : '&apos;',
            '"' : '&quot;'
        }
        const re = new RegExp('['+Object.keys(TT).join('')+']', "gm");
        return data.replace(re, c => TT[c]);
    }

    function array2xml(v) {
        var xml = '';
        indent++;
        for(var i in v)
            xml += value2xml(v[i][0], v[i][1], v[i][2]);
        indent--;
        return xml;
    }

    function value2xml(name, attr, v) {
        var tabs = '';
        for(var i=0; i<indent; i++) tabs += '  ';

        var name_attrs = name;
        for(var n in attr)
            name_attrs += ' '+n+'="'+escape(attr[n])+'"';

        return !v ? tabs+'<'+name_attrs+'/>\n'
                  : tabs+'<'+name_attrs+'>'
                  + (v instanceof Array ? (v.length ? '\n'+array2xml(v)+tabs : '') : escape(v))
                  + '</'+name+'>\n';
    }

    return '<?xml version="1.0" encoding="UTF-8" standalone="no"?>\n'
          + value2xml(v[0], v[1], v[2]);
}

module.exports = Object.assign({stringify}, require('./xml2json'));
